# coding=utf8

# Copyright 2018 JDCLOUD.COM
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# NOTE: This class is auto generated by the jdcloud code generator program.

from jdcloud_sdk.core.jdcloudrequest import JDCloudRequest


class ApplyTemplateRequest(JDCloudRequest):
    """
    应用报警模板到资源
    """

    def __init__(self, parameters, header=None, version="v1"):
        super(ApplyTemplateRequest, self).__init__(
            '/template/{templateId}/resources', 'POST', header, version)
        self.parameters = parameters


class ApplyTemplateParameters(object):

    def __init__(self, templateId, clientToken, dataCenters, resourceIds, serviceCode, templateType, ):
        """
        :param templateId: 模板 id
        :param clientToken: 幂等性校验参数,最长36位
        :param dataCenters: dataCenters，该资源所处地域，与resourceIds一一对应
        :param resourceIds: 资源ID列表，resourceIds数量为1--40，每一项不能为空或包含*
        :param serviceCode: 资源类型
        :param templateType: 模板类型，1表示默认模板，2表示用户自定义模板
        """

        self.templateId = templateId
        self.clientToken = clientToken
        self.contacts = None
        self.dataCenters = dataCenters
        self.resourceIds = resourceIds
        self.serviceCode = serviceCode
        self.tagsArray = None
        self.templateType = templateType
        self.webHookContent = None
        self.webHookProtocol = None
        self.webHookSecret = None
        self.webHookUrl = None

    def setContacts(self, contacts):
        """
        :param contacts: (Optional) 联系人列表
        """
        self.contacts = contacts

    def setTagsArray(self, tagsArray):
        """
        :param tagsArray: (Optional) 标签组，模板下面规则对应的tags，与resourceIds一一对应
        """
        self.tagsArray = tagsArray

    def setWebHookContent(self, webHookContent):
        """
        :param webHookContent: (Optional) 回调content 注:仅webHookUrl和webHookContent均不为空时,才会创建webHook
        """
        self.webHookContent = webHookContent

    def setWebHookProtocol(self, webHookProtocol):
        """
        :param webHookProtocol: (Optional) webHook协议,https或http 注:此处需和webHookUrl相匹配
        """
        self.webHookProtocol = webHookProtocol

    def setWebHookSecret(self, webHookSecret):
        """
        :param webHookSecret: (Optional) 回调secret,用户请求签名,防伪造
        """
        self.webHookSecret = webHookSecret

    def setWebHookUrl(self, webHookUrl):
        """
        :param webHookUrl: (Optional) 回调url
        """
        self.webHookUrl = webHookUrl

