# coding=utf8

# Copyright 2018 JDCLOUD.COM
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# NOTE: This class is auto generated by the jdcloud code generator program.

from jdcloud_sdk.core.jdcloudrequest import JDCloudRequest


class CreateTemplateRequest(JDCloudRequest):
    """
    创建自定义报警模板
    """

    def __init__(self, parameters, header=None, version="v1"):
        super(CreateTemplateRequest, self).__init__(
            '/template', 'POST', header, version)
        self.parameters = parameters


class CreateTemplateParameters(object):

    def __init__(self, clientToken, ruleServiceCode, serviceCode, templateName, templateRules):
        """
        :param clientToken: 幂等性校验参数,最长36位
        :param ruleServiceCode: 规则的资源类型
        :param serviceCode: 模板的资源类型
        :param templateName: 模板名称,长度1-32个字符，只允许中英文、数字、''-''和"_"
        :param templateRules: 模板内包含的规则
        """

        self.clientToken = clientToken
        self.description = None
        self.ruleServiceCode = ruleServiceCode
        self.serviceCode = serviceCode
        self.templateName = templateName
        self.templateRules = templateRules

    def setDescription(self, description):
        """
        :param description: (Optional) 模板描述
        """
        self.description = description

