# coding=utf8

# Copyright 2018 JDCLOUD.COM
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# NOTE: This class is auto generated by the jdcloud code generator program.

from jdcloud_sdk.core.jdcloudrequest import JDCloudRequest


class DescribeMetricDataCmRequest(JDCloudRequest):
    """
    查询自定义监控的metric数据
    """

    def __init__(self, parameters, header=None, version="v1"):
        super(DescribeMetricDataCmRequest, self).__init__(
            '/regions/{regionId}/cm/namespaces/{namespaceUID}/objs/{objUID}/metricData', 'POST', header, version)
        self.parameters = parameters


class DescribeMetricDataCmParameters(object):

    def __init__(self, regionId, namespaceUID, objUID, ):
        """
        :param regionId: region
        :param namespaceUID: region
        :param objUID: region
        """

        self.regionId = regionId
        self.namespaceUID = namespaceUID
        self.objUID = objUID
        self.aggrType = None
        self.endTime = None
        self.metricUID = None
        self.startTime = None
        self.timeInterval = None

    def setAggrType(self, aggrType):
        """
        :param aggrType: (Optional) 
        """
        self.aggrType = aggrType

    def setEndTime(self, endTime):
        """
        :param endTime: (Optional) 查询时间范围的结束时间， UTC时间，格式：2016-12- yyyy-MM-dd'T'HH:mm:ssZ（为空时，将由startTime与timeInterval计算得出）
in: query
        """
        self.endTime = endTime

    def setMetricUID(self, metricUID):
        """
        :param metricUID: (Optional) metric id列表
in: query
        """
        self.metricUID = metricUID

    def setStartTime(self, startTime):
        """
        :param startTime: (Optional) 查询时间范围的开始时间， UTC时间，格式：yyyy-MM-dd'T'HH:mm:ssZ（默认为当前时间，早于30d时，将被重置为30d）
in: query
        """
        self.startTime = startTime

    def setTimeInterval(self, timeInterval):
        """
        :param timeInterval: (Optional) 时间间隔：1h，6h，12h，1d，3d，7d，14d，固定时间间隔，timeInterval 与 endTime 至少填一项
in: query
        """
        self.timeInterval = timeInterval

