# coding=utf8

# Copyright 2018 JDCLOUD.COM
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# NOTE: This class is auto generated by the jdcloud code generator program.

from jdcloud_sdk.core.jdcloudrequest import JDCloudRequest


class DescribeProbeTasksRequest(JDCloudRequest):
    """
    查询可用性监控任务列表
    """

    def __init__(self, parameters, header=None, version="v1"):
        super(DescribeProbeTasksRequest, self).__init__(
            '/am/probeTask', 'GET', header, version)
        self.parameters = parameters


class DescribeProbeTasksParameters(object):

    def __init__(self, probeTaskID, ):
        """
        :param probeTaskID: 探测任务的task_id
        """

        self.probeTaskID = probeTaskID
        self.pageNumber = None
        self.pageSize = None
        self.name = None
        self.type = None

    def setPageNumber(self, pageNumber):
        """
        :param pageNumber: (Optional) 当前所在页，默认为1
        """
        self.pageNumber = pageNumber

    def setPageSize(self, pageSize):
        """
        :param pageSize: (Optional) 页面大小，默认为20；取值范围[1, 100]
        """
        self.pageSize = pageSize

    def setName(self, name):
        """
        :param name: (Optional) 根据探测任务的名称查询，支持模糊查询
        """
        self.name = name

    def setType(self, type):
        """
        :param type: (Optional) 根据探测任务的类型查询，1、http 2、telnet
        """
        self.type = type

