# coding=utf8

# Copyright 2018 JDCLOUD.COM
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# NOTE: This class is auto generated by the jdcloud code generator program.

from jdcloud_sdk.core.jdcloudrequest import JDCloudRequest


class DescribeTemplatesRequest(JDCloudRequest):
    """
    查询报警模板
    """

    def __init__(self, parameters, header=None, version="v1"):
        super(DescribeTemplatesRequest, self).__init__(
            '/template', 'GET', header, version)
        self.parameters = parameters


class DescribeTemplatesParameters(object):

    def __init__(self, templateType):
        """
        :param templateType: 模板类型，区分默认模板和用户自定义模板：1表示默认模板，2表示用户自定义模板
        """

        self.pageNumber = None
        self.pageSize = None
        self.serviceCode = None
        self.templateName = None
        self.templateType = templateType

    def setPageNumber(self, pageNumber):
        """
        :param pageNumber: (Optional) 当前所在页，默认为1
        """
        self.pageNumber = pageNumber

    def setPageSize(self, pageSize):
        """
        :param pageSize: (Optional) 页面大小，默认为20；取值范围[1, 100]
        """
        self.pageSize = pageSize

    def setServiceCode(self, serviceCode):
        """
        :param serviceCode: (Optional) 产品线标识
        """
        self.serviceCode = serviceCode

    def setTemplateName(self, templateName):
        """
        :param templateName: (Optional) 模板名称
        """
        self.templateName = templateName

